"plot.hmm.path" <-
function(hmmPath, dat.col="orange", fit.col="seagreen", main=NULL){
  path = hmmPath$path
  L    = hmmPath$L
  p    = hmmPath$p
  x    = hmmPath$x
  seg  = hmmPath$segment
  Z   = length(path)

  min.x = min(x)
  max.x = max(x)
  rag.x = max.x - min.x
  y.lim = c(min.x-0.2*rag.x, max.x+0.2*rag.x)

  if(is.null(main)){
    main = "hidden states based on viterbi algorithm"
  }
  plot(p, x, ylim = y.lim, type="l", col=dat.col, 
      xlab = "position", ylab="signal", lwd=1.5, main=main)

  xS = floor(min(p)/L)*L + L*(1:Z) - L/2

  states = unique(path)
  rbcols = rainbow(length(states))
  for(i in 1:length(states)){
      st = states[i]
      xI = xS[path==st]
      yI = rep(min.x-0.1*rag.x, length(xI))
      points(xI, yI, pch=as.character(st), col=rbcols[i])
  }

  lines(seg$p, seg$x, lty=2, col=fit.col, lwd=2)
}
