"post.prob" <-
function(f, b, D, cut=0.5){

    if(!is.list(f) || !is.list(b)){
        stop("both f and b must be list\n")
    }
    
    if(length(f) != length(b)){
        stop("f and b should have the same length\n")
    }
    
    m = length(f)
    if(m < 2){
        stop("there should be at least two states\n")
    }

    fR = f[[1]]
    Z = nrow(fR)
    for(i in 2:m){
        fR = rbind(fR, f[[i]])
    }

    bR = b[[1]]
    for(i in 2:m){
        bR = rbind(bR, b[[i]])
    }

    post.p = matrix(0, nrow=Z, ncol=m)
    
    dims = c(m, D, Z)


    fR = as.double(t(fR))
    fR.inf = is.infinite(fR)
    if(length(which(fR.inf & fR>0))>0){
        stop("there are positive infinite values in forward probabilities\n")
    }
    fR[which(fR.inf)] = 0.0
    fR.inf = as.integer(fR.inf)
    
    bR = as.double(t(bR))
    bR.inf = is.infinite(bR)
    if(length(which(bR.inf & bR>0))>0){
        stop("there are positive infinite values in backward probabilities\n")
    }
    bR[which(bR.inf)] = 0.0
    bR.inf = as.integer(bR.inf)
   
    SW = .C("post_prob", fR, fR.inf, bR,  bR.inf,  
        postP=as.double(post.p), as.integer(dims), as.double(cut), 
        PACKAGE="ss.hmm");
    
    post.p = matrix(SW$postP, byrow=TRUE, nrow=Z, ncol=m)
    
    post.p
}
