#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void print_v(double* v, int nrl, int nrh)
{
	int i;
	for (i = nrl; i < nrh; i++){
		printf ("%f\t", v[i]);
	}
	printf ("%f\n", v[i]);
}

int comp_double_rev(const double *num1, const double *num2)
{
  if (*num1 >  *num2) return -1;
  if (*num1 == *num2) return  0;
  if (*num1 <  *num2) return  1;
}

int is_infinite (const double x){
    double y = x - x;
    int s = (y!=y);
    
    if(s && x >0)
        return +1;
    else if(s && x < 0)
        return -1;
    else
        return 0;
}

double logsumexp(double* vv, int nl, int nh, double cut)
{
    int i, d, n, is_inf;
    double res, v0, lse;
    double* v;
	v = (double *)calloc(nh-nl+1, sizeof(double));

    n = 0; /* length of vector v */
    for(i=nl; i<=nh; i++){
        is_inf = is_infinite(vv[i]);
        printf("i=%d, vv[i]=%f, is_inf=%d\n", i, vv[i], is_inf);
        if(is_inf == 0){
            v[n] = vv[i];
            n++;
        }else if(is_inf>0){
            printf("positive infinite number in logsumexp\n");
            // exit(99);
        }
    }
    
    if(n==0)
        return(-1/0.0);
    if(n==1)
        return(v[1]);

    printf("before sorting\n");
    print_v(v, 0, n-1);
    qsort(v, n, sizeof(double), (void*)comp_double_rev);
    printf("after sorting\n");
    print_v(v, 0, n-1);

    res = 0.0;
    v0  = v[0];
    for(i=1; i<n; i++){
        res += exp(v[i] - v0);
    }
    if(n==2 || res < cut){
        lse = v0 + res - res*res/2 + pow(res,3)/3 - pow(res,4)/4 + pow(res,5)/5;
    }else{
        for(d=2; d<n; d++){
            v0  = logsumexp(v, 0, d-1, cut);
            res = 0.0;
            for(i=d; i<n; i++){
                res += exp(v[i] - v0);
            }
            if(res < cut){ break; }
        }
        lse = v0 + res - res*res/2 + pow(res,3)/3 - pow(res,4)/4 + pow(res,5)/5;
    }
    return(lse);
}


int main(){ 
    int i, j;
    double a, b, c, d, z;
    double v[] = {1.0, 2.0, log(0.0), -log(0.0)};
    a = log(0.0);
    b = -1.0/0.0;
    c = a-b;
    d = a+b;
    
    i = is_infinite(a);
    j = is_infinite(c);

    printf("a=%f, b=%f, c=%f, d=%f, i=%d, j=%d\n", a, b, c, d, i, j);
    
    z = logsumexp(v, 0, 3, 0.5);
    printf("z=%f\n", z);
    
    if(b>a){
        printf("b>a\n");
    }
    if(c>a){
        printf("c>a\n");
    }
}
