\name{duration}
\alias{duration}
\title{ calculate duration probability }
\description{
    calculate duration probability
}
\usage{
duration(D, step, shape, scale, lb, ub, mu3, sd3, mu4, sd4)
}
\arguments{
  \item{D}{ maximum duration }
  \item{step}{ how many bases per step }
  \item{shape}{ parameter of dgamma(shape, scale) }
  \item{scale}{ parameter of dgamma(shape, scale) }
  \item{lb}{ parameter of dunif(lb, ub) }
  \item{ub}{ parameter of dunif(lb, ub) }
  \item{mu3}{ parameter of dnorm(mu3, sd3) }
  \item{sd3}{ parameter of dnorm(mu3, sd3) }
  \item{mu4}{ parameter of dnorm(mu4, sd4) }
  \item{sd4}{ parameter of dnorm(mu4, sd4) }
}

\details{
  duration of 4 different states:
  \item{state 1 }{duration of state 1, long flat line follows gamma distribution dgamma(shape, scale). }
  \item{state 2 }{duration of state 2, short flat line follows uniform distribution dunif(lb, ub). state}
  \item{state 3 }{duration of state 3, negative slope line follows normal distribution dnorm(mu3, sd3)}
  \item{state 4 }{duration of state 4, positive slope line follows normal distribution dnorm(mu4, sd4)}
}
\value{
    du: a matrix of size D*m. 
    du[t,i] = Prob(duration of state i = t)
}
\references{  }
\author{ Wei Sun sunwei@stat.ucla.edu }
\note{ }

\examples{

}
\keyword{ utilities }
